package foo.rebooter;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.os.PowerManager;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

/**
 * W tej aktywnoci pokazano dwa sposoby ponownego uruchamiania urzdzenia:
 * oficjalny, ale standardowo niewykonalny (opracowany przez iana),
 * i sztuczk opart na przecieniu systemu (opracowany przez Saketa).
 */
public class Main extends Activity {
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		Button b1 = (Button) findViewById(R.id.bootNormalButton);
		b1.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				PowerManager pwrMgr = (PowerManager) getSystemService(Context.POWER_SERVICE);
				Toast.makeText(Main.this, 
					"Sprbuj ponownie uruchomi system, ale pewnie si nie uda", Toast.LENGTH_LONG).show();
				pwrMgr.reboot(null);
				Toast.makeText(Main.this, 
					"Jeszcze mniej prawdopodobne - nadal dziaa po prbie ponownego uruchomienia!", Toast.LENGTH_LONG).show();
			}
		});
		Button b2 = (Button) findViewById(R.id.bootHackButton);
		b2.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Toast.makeText(Main.this, 
						"Prba ponownego uruchomienia przez wyczerpanie zasobw", Toast.LENGTH_LONG).show();
				while (true) {
					Toast.makeText(Main.this, 
						"Hakowanie urzdzenia w toku", Toast.LENGTH_LONG).show();
				}
			}
		});
	}
}